﻿--[[****************************************************************
	Pet! v1.00

	Author: Evil Duck
	****************************************************************

	For the game World of Warcraft
	Fish! displays the zone where a fish can be obtained through fishing.

	****************************************************************]]

-- 1.00 First version


local addonName,PRIVATE=...;	-- Blizzard passes us the addon name and a table to all addon files in the ellipsis variable
PRIVATE.Code={};				-- create a subtable to store our utility functions so we can call them from anywhere in our addon without making them global
local fish=PRIVATE.Code;		-- get a reference to our functions table with a friendly/short name
local _;
FISH_Storage=0;
PRIVATE.frame=CreateFrame("Frame",nil,UIParent);
local frame=PRIVATE.frame;
frame:RegisterEvent("LOOT_OPENED");
frame:RegisterEvent("ADDON_LOADED");
local Yellow="|cFFFFFF00";
local dYellow="|cFF808000";
local Orange="|cFFE04224";

local function getid(link)
	return tonumber(tostring(link):match("item:(%-?%d*):%-?%d*:%-?%d*:%-?%d*:%-?%d*:%-?%d*:%-?%d*"));
end
local function CurrentMap()
	local x,y=GetPlayerMapPosition("player");
	if (x<=0 and y<=0 ) then return nil; end		-- we're off the map - no need to try to fix it, so abort
	return GetCurrentMapAreaID();					-- grab map id and level
end

function frame.OnEvent(_,event,...)
	if (frame[event]) then return frame[event](...); end end

function frame.ADDON_LOADED(addon)
	if (addon=="Fish") then frame.Unregister(addon); end
	if (type(FISH_Storage)~="table") then
	FISH_Storage = {
	[201] = { ["Item"] = { [21153] = 18, }, ["Total"] = 18, },
	[490] = { ["Item"] = { [41809] = 15, [41802] = 8, [40199] = 16, [41808] = 1, [45190] = 1, }, ["Total"] = 25, },
	[382] = { ["Item"] = { [6297] = 5, [6299] = 3, [6308] = 9, [6289] = 10, [6291] = 3, }, ["Total"] = 30, },
	[182] = { ["Item"] = { [6358] = 2, [13758] = 8, [8365] = 2, [13759] = 2, [13760] = 1, }, ["Total"] = 15, },
	[488] = { ["Item"] = { [40199] = 18, [41802] = 10, [44475] = 3, [41807] = 10, }, ["Total"] = 23, },
	[9] = { ["Item"] = { [6289] = 11, [6291] = 9, }, ["Total"] = 20, },
	[473] = { ["Item"] = { [27441] = 15, }, ["Total"] = 15, },
	[615] = { ["Item"] = { [53069] = 9, [45191] = 2, [45195] = 1, [45189] = 1, }, ["Total"] = 13, },
	[19] = { ["Item"] = { [6358] = 1, [13422] = 4, [21150] = 2, [21153] = 16, [3820] = 1, }, ["Total"] = 24, },
	[38] = { ["Item"] = { [6358] = 3, [13422] = 10, [21150] = 3, [21151] = 2, [21228] = 3, [6359] = 5, }, ["Total"] = 26, },
	[20] = { ["Item"] = { [6289] = 13, [6299] = 2, [6291] = 14, [6301] = 1, }, ["Total"] = 30, },
	[700] = { ["Item"] = { [53072] = 8, [52326] = 3, [53064] = 33, }, ["Total"] = 44, },
	[21] = { ["Item"] = { [6297] = 7, [6299] = 5, [6308] = 4, [6289] = 10, [6291] = 4, }, ["Total"] = 30, },
	[281] = { ["Item"] = { [13757] = 1, [13759] = 6, [45197] = 1, [13889] = 11, [45198] = 3, [13758] = 2, [13760] = 8, [45200] = 4, [45190] = 4, }, ["Total"] = 40, },
	[22] = { ["Item"] = { [8365] = 15, [6308] = 15, }, ["Total"] = 30, },
	[181] = { ["Item"] = { [3820] = 1, [21071] = 6, [6308] = 4, [6289] = 6, [6291] = 3, }, ["Total"] = 20, },
	[23] = { ["Item"] = { [8365] = 27, [21151] = 3, [21150] = 5, [21153] = 38, [6308] = 10, }, ["Total"] = 83, },
	[362] = { ["Item"] = { [6289] = 12, [6308] = 2, [6291] = 6, }, ["Total"] = 20, },
	[24] = { ["Item"] = { [21071] = 3, [6308] = 17, [3820] = 1, [6289] = 9, }, ["Total"] = 30, },
	[673] = { ["Item"] = { [6358] = 5, [6359] = 5, [21151] = 1, [21150] = 1, }, ["Total"] = 12, },
	[720] = { ["Item"] = { [52326] = 2, [53066] = 15, }, ["Total"] = 17, },
	[161] = { ["Item"] = { [6358] = 4, [13422] = 11, [21150] = 2, [21151] = 3, [3820] = 4, [21228] = 8, [6359] = 6, }, ["Total"] = 38, },
	[477] = { ["Item"] = { [27435] = 4, [27422] = 2, [27437] = 8, [27515] = 1, [22578] = 5, [27513] = 2, }, ["Total"] = 22, },
	[26] = { ["Item"] = { [45194] = 3, [21150] = 2, [45196] = 1, [8365] = 42, [6308] = 21, [45198] = 4, [6311] = 1, [45200] = 11, [21153] = 14, [21151] = 1, [45190] = 5, }, ["Total"] = 105, },
	[493] = { ["Item"] = { [40199] = 5, [41813] = 11, [45194] = 1, }, ["Total"] = 12, },
	[614] = { ["Item"] = { [45188] = 2, [45190] = 1, [53069] = 7, }, ["Total"] = 10, },
	[478] = { ["Item"] = { [27511] = 2, [22578] = 3, [27438] = 7, [27439] = 10, [27513] = 2, }, ["Total"] = 24, },
	[486] = { ["Item"] = { [40199] = 13, [44475] = 1, [41806] = 13, [41807] = 3, [45190] = 1, [41808] = 8, [45198] = 2, [45194] = 1, [37705] = 1, [41805] = 7, [45196] = 1, }, ["Total"] = 38, },
	[491] = { ["Item"] = { [41810] = 35, [37705] = 6, [41802] = 11, [44475] = 2, [40199] = 32, }, ["Total"] = 54, },
	[11] = { ["Item"] = { [21071] = 5, [6303] = 1, [20708] = 2, [6455] = 2, [21114] = 1, [6522] = 6, [6358] = 3, [4363] = 1, [6361] = 1, [6289] = 2, }, ["Total"] = 24, },
	};
		print(Orange.."Fish!|r","Database initialized.");
	end
end

function frame.LOOT_OPENED()
	if (not IsFishingLoot()) then return; end
	local slots=GetNumLootItems(); if (slots<1) then return; end		-- nothing, so don't even bother counting
--print(Orange.."Fish!|r","Fishing loot:");
	local m=CurrentMap(); if (not m) then return; end					-- mapID
--print(Orange.."Fish!|r",m,GetMapNameByID(m));
	local p=FISH_Storage[m] or { Total=0, Item={}, };					-- grab this map fishing info
	p.Total=p.Total+1;													-- count this loot
	for i=1,slots do
		local thisi=getid(GetLootSlotLink(i));
		if (thisi) then
			p.Item[thisi]=(p.Item[thisi] or 0)+1;						-- fished this item, so count it
--local name; _,name,_=GetLootSlotInfo(i);		-- icon, name, quantity
--print(Orange.."Fish!|r",name..":",p.Item[thisi].."/"..p.Total,"("..ceil((100/p.Total)*p.Item[thisi]).."%)");
	end end
	FISH_Storage[m]=p;													-- save map info
end

-- hooked for setting items at tooltips
function fish.SetBagItem(self,bag,slot)
	local ret={fish._SetBagItem(self,bag,slot)};
	local _,item=self:GetItem();
	fish.AddFishingStats(self,item);
	return unpack(ret);
end
function fish.SetGuildBankItem(self,tab,slot)
	fish._SetGuildBankItem(self,tab,slot);
	local _,item=self:GetItem();
	fish.AddFishingStats(self,item);
end
function fish.SetAuctionItem(self,list,index)
	local ret={fish._SetAuctionItem(self,list,index)};
	local _,item=self:GetItem();
	fish.AddFishingStats(self,item);
	return unpack(ret);
end

function fish.AddFishingStats(frame,item)
	if (not item) then return; end										-- nothing to do
	local cm=CurrentMap() or 101010101;									-- just some unlikely number
	local header="Fish!";
	item=getid(item);			-- grab item number
	for map,md in pairs(FISH_Storage) do
		if (md.Item[item]) then
			frame:Add(Orange..header,(cm==map and Yellow or dYellow).."  "..GetMapNameByID(map)..": "..ceil((100/md.Total)*md.Item[item]).."%"); header=" ";
		end
	end
	if (header==" ") then frame:Show(); end								-- resize if something was added
end

frame:SetScript("OnEvent",frame.OnEvent);
fish._SetBagItem=GameTooltip.SetBagItem; GameTooltip.SetBagItem=fish.SetBagItem;
fish._SetGuildBankItem=GameTooltip.SetGuildBankItem; GameTooltip.SetGuildBankItem=fish.SetGuildBankItem;
fish._SetAuctionItem=GameTooltip.SetAuctionItem; GameTooltip.SetAuctionItem=fish.SetAuctionItem;
